# Contributing to Themis

Themis is an open-source, Apache 2 licensed software, maintained by [Cossack Labs](https://www.cossacklabs.com) for building reliable cryptography in our products: [Acra](https://www.github.com/cossacklabs/acra), [Hermes](https://www.cossacklabs.com/hermes) and [Toughbase](https://www.cossacklabs.com/toughbase). You can hack it any way you want and contribute things back if you need something more than what we provide. As a development company, we focus on implementing features that are important to our products but would gladly spend some time to make Themis useful for everybody.

We highly encourage you to: 

  - Report any bugs and request features via [GitHub Issues](https://github.com/cossacklabs/themis/issues).
  - Report a bug and fix it with a patch via our [GitHub Pull request](https://github.com/cossacklabs/themis/pulls) (after issuing a corresponding issue and leaving a link to pull there).
  - Participate in the theoretical development and design of Themis in the corresponding [Google Group](https://groups.google.com/d/forum/devthemis).
  - Add something new to Themis. There is a certain design scheme according to which we'd like to keep developing Themis, and if your contributions fall along with it, we'd be more than glad to accept some fundamental additions. It's better to discuss the subject using [email](mailto:dev@cossacklabs.com) or our Google Group before taking action.


Every commit that goes into the master branch is audited and reviewed by somebody from Cossack Labs, so don't be surprised if it takes longer than you expect. 

## "I'd like to help somehow, but don't know what will be useful. What should I do?"

There's a Development [status page](https://github.com/cossacklabs/themis/wiki/Development-status), which displays what we're working on right now and what critical stuff is not there yet. If you'd like to take over any of those tasks, get in touch or just raise an issue and work on it. 

If you'd like to do independent parts (implement new procedures/objects, do a language wrapper or a set of examples for languages or architectures we don't have and don't even plan yet) — just go ahead and let us know when you finish. 

If you'd like to participate in the core development more closely, get in touch. 

### Getting in touch

- Requests/bugfixes/queries should go through [Github Issues](https://github.com/cossacklabs/themis/issues)
- In-depth discussions, help in using Themis, and possible ways of collaboration can be found in our [Google Group](https://groups.google.com/d/forum/devthemis).
- To reach the developers, use [dev@cossacklabs.com](mailto:dev@cossacklabs.com).
- To talk to the business wing of Cossack Labs, drop us an email to [info@cossacklabs.com](mailto:info@cossacklabs.com).
