# Rust-Themis

[![crates.io][crates-io-badge]][crates-io]
[![CircleCI][circle-ci-badge]][circle-ci]
[![License][license-badge]][license]

Rust wrapper for [Themis] crypto library.

[Themis]: https://github.com/cossacklabs/themis
[crates-io]: https://crates.io/crates/themis
[crates-io-badge]: https://img.shields.io/crates/v/themis.svg
[circle-ci]: https://circleci.com/gh/cossacklabs/themis/tree/master
[circle-ci-badge]: https://circleci.com/gh/cossacklabs/themis/tree/master.svg?style=shield
[license]: LICENSE
[license-badge]: https://img.shields.io/crates/l/themis.svg

## Quickstart

Rust-Themis requires a native Themis library.
Please refer to the [Quickstart guide] for the installation instructions.

Documentation may be found here:

 - [General documentation in Themis Wiki][Wiki],    
 - [In-depth documentation on our Documentation Server][Documentation Server],     
 - [Rust API documentation on Docs.rs][Docs.rs],     
 - [Changelog on GitHub][CHANGELOG].

You can start experimenting with [Examples]
or take a look at [Tests]
to get a feeling of how Themis can be used.

[Quickstart guide]: https://github.com/cossacklabs/themis/wiki/Rust-Howto
[Wiki]: https://github.com/cossacklabs/themis/wiki
[Docs.rs]: https://docs.rs/themis
[Documentation Server]: https://docs.cossacklabs.com/products/themis/
[CHANGELOG]: /src/wrappers/themis/rust/CHANGELOG.md
[Examples]: /docs/examples/rust
[Tests]: /tests/rust

## Licensing

The code is distributed under [Apache 2.0 license](LICENSE).
